FortunaDiceRoller = LibStub("AceAddon-3.0"):NewAddon("FortunaDiceRoller", "AceConsole-3.0", "AceEvent-3.0")

function FortunaDiceRoller:GetMessage(info)
    return self.message
end

function FortunaDiceRoller:SetMessage(info, newValue)
    self.message = newValue
end

local options = { 
    name = "FortunaDiceRoller",
    handler = FortunaDiceRoller,
    type = "group",
    args = {
        msg = {
            type = "input",
            name = "Message",
            desc = "The message to be displayed when you get home.",
            usage = "<Your Message Here>",
            get = "GetMessage",
            set = "SetMessage",
        },
    },
}

local defaults = {
    profile = {
        message = "FortunaDiceRoller active!",
        showInChat = false,
        showOnScreen = true,
    },
}

function FortunaDiceRoller:OnInitialize()
    -- Called when the addon is loaded
	self.db = LibStub("AceDB-3.0"):New("FDRDB", defaults, true)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("FortunaDiceRoller", options, {"fortunadiceroller", "FortunaDiceRoller"})
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("FortunaDiceRoller", "FortunaDiceRoller")
	self:RegisterChatCommand("fortunadiceroller", "ChatCommand")
    self:RegisterChatCommand("fdr", "ChatCommand")
	FortunaDiceRoller.message = "Welcome Home!"
	FortunaDiceRoller.testmessage = "FortunaDiceRoller Test message!"
end

function FortunaDiceRoller:OnEnable()
    -- Called when the addon is enabled
	self:Print(self.testmessage)
	self:RegisterEvent("ZONE_CHANGED")
end

function FortunaDiceRoller:OnDisable()
    -- Called when the addon is disabled
end

function FortunaDiceRoller:ZONE_CHANGED()
    if GetBindLocation() == GetSubZoneText() then
        self:Print(self.message)
    end
end

function FortunaDiceRoller:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
    else
        LibStub("AceConfigCmd-3.0"):HandleCommand("fdr", "fortunadiceroller", input)
    end
end